unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, DSPack, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, DXSUtil, DirectShow9, ActiveX, windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DSTrackBar1: TDSTrackBar;
    fgRender: TFilterGraph;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    VideoWindow1: TVideoWindow;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation
var
  mc                                     : IMediaControl;
  mEvent                                 : IMediaEvent;
  hr                                     : HRESULT;
  ICapGraph                              : ICaptureGraphBuilder2;
  mt                                     : AM_Media_Type;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  fgRender.ClearGraph;
  fgRender.Active:=False;
  mc.Stop;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   fgRender.play;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  fgRender.Pause;
end;

procedure TForm1.Button1Click(Sender: TObject);
const sVideoRenderCategory: string ='External Renderers';
      sVideoRender:string = 'Decklink Video Render';
      CLSID_LAV_SPLITTER : TGUID = '{171252A0-8820-4AFE-9DF8-5C92B2D66B04}';
var
  i,j                                    : integer;
  SysDev, FilterEnum                     : TSysDevEnum;
  CLSID_VideoRender, G                   : TGUID;
  mt     : AM_Media_Type;
  rcSrc  : Rect;
  SourceFilter, EstAudioInterFilter,
  IVideoRenderFilter, DefaultAudioFilter,
  LAVSplitter,
  InfinitePinFilterAudio,
  InfinitePinFilter                      : IBaseFilter;
//  seqHdr : MPEG2VIDEOINFO;
  seqHdr : array[0..0] of Byte;
  // c    sequence header
{ SeqHdr : array[0..0] of byte {
0x00, 0x00, 0x01, 0xb3, 0x2d, 0x02, 0x40, 0x33,
0x24, 0x9f, 0x23, 0x81, 0x10, 0x11, 0x11, 0x12,
0x12, 0x12, 0x13, 0x13, 0x13, 0x13, 0x14, 0x14,
0x14, 0x14, 0x14, 0x15, 0x15, 0x15, 0x15, 0x15,
0x15, 0x16, 0x16, 0x16, 0x16, 0x16, 0x16, 0x16,
0x17, 0x17, 0x17, 0x17, 0x17, 0x17, 0x17, 0x17,
0x18, 0x18, 0x18, 0x19, 0x18, 0x18, 0x18, 0x19,
0x1a, 0x1a, 0x1a, 0x1a, 0x19, 0x1b, 0x1b, 0x1b,
0x1b, 0x1b, 0x1c, 0x1c, 0x1c, 0x1c, 0x1e, 0x1e,
0x1e, 0x1f, 0x1f, 0x21 }    }

  pWIH : MPEG2VIDEOINFO;
  PinOutSource,PIn_input : IPin;
begin
  fgRender.ClearGraph;
 (fgRender as IGraphBuilder).QueryInterface(IID_IMediaControl, mc);
 (fgRender as IGraphBuilder).QueryInterface(IID_IMediaEvent, mEvent);
//****************************************************************
// C:\film\01\Fringe1920x1080_25p.mpg
// C:\film\01\Fringe720x576.mpg
hr := (fgRender as IGraphBuilder).AddSourceFilter(StringToOleStr('C:\film\01\Fringe720x576.mpg'),
    'Source Filter', SourceFilter);
//***********  External device   DeckLink ********************
{ SysDev:= TSysDevEnum.Create;
for i:= 0 to SysDev.CountCategories-1 do
  begin
  if SysDev.Categories[i].FriendlyName = sVideoRenderCategory then
    begin
	G:=SysDev.Categories[i].CLSID;
	FilterEnum:=TSysDevEnum.Create(G);
	for j:= 0 to FilterEnum.CountFilters-1 do
      begin
      if FilterEnum.Filters[j].FriendlyName= sVideoRender then
        begin
//        CLSID_TransmitCategory := FilterEnum.Filters[j].CLSID;
        CLSID_VideoRender:=FilterEnum.Filters[j].CLSID;
        break;
        end;
      end;
    end;
  end;
SysDev.Free;
FilterEnum.Free;

hr := CoCreateInstance(CLSID_VideoRender,nil, CLSCTX_INPROC_SERVER,
                      IID_IBaseFilter,IVideoRenderFilter);

//(fgRender as IGraphBuilder).AddFilter(IVideoRenderFilter,'Decklink Video Render');
(fgRender as IGraphBuilder).AddFilter(IVideoRenderFilter,PWideChar(sVideoRender));
 }
//********************************************************************************
//******************** AUDIO DECKLINK ***************************************
  {
   SysDev:= TSysDevEnum.Create;
for i:= 0 to SysDev.CountCategories-1 do
  begin
  if SysDev.Categories[i].FriendlyName = 'Audio Renderers' then
    begin
	G:=SysDev.Categories[i].CLSID;
    FilterEnum:=TSysDevEnum.Create(G);
	for j:= 0 to FilterEnum.CountFilters-1 do
      begin
//    if FilterEnum.Filters[j].FriendlyName = 'Altoparlanti (Blackmagic Audio)' then
      if FilterEnum.Filters[j].FriendlyName = 'Decklink Audio Render' then
        begin
        CLSID_AudioRender:= FilterEnum.Filters[j].CLSID;
        break;
        end;
      end;
    end;
  end;
SysDev.Free;
FilterEnum.Free;
hr := CoCreateInstance(CLSID_AudioRender, nil,
                       CLSCTX_INPROC_SERVER, IID_IBaseFilter,
					   EstAudioInterFilter);
(fgRender as IGraphBuilder).AddFilter(EstAudioInterFilter,'Decklink Audio Render');
  }
//*******************  Default DirectSound Device ************************
    SysDev:= TSysDevEnum.Create;
for i:= 0 to SysDev.CountCategories-1 do
  begin
  if SysDev.Categories[i].FriendlyName = 'Audio Renderers' then
    begin
	G:=SysDev.Categories[i].CLSID;
    FilterEnum:=TSysDevEnum.Create(G);
	for j:= 0 to FilterEnum.CountFilters-1 do
      begin
      if FilterEnum.Filters[j].FriendlyName = 'Default DirectSound Device' then
        begin
        CLSID_AudioRender:= FilterEnum.Filters[j].CLSID;
        break;
        end;
      end;
    end;
  end;
SysDev.Free;
FilterEnum.Free;
hr := CoCreateInstance(CLSID_AudioRender, nil, CLSCTX_INPROC_SERVER,
                       IID_IBaseFilter, DefaultAudioFilter);
(fgRender as IGraphBuilder).AddFilter(DefaultAudioFilter,
                              'Default DirectSound Device');

 //*************************************************************
//******************  LAV Splitter ******************************
 {
SysDev:= TSysDevEnum.Create;
for i:= 0 to SysDev.CountCategories-1 do
begin
if SysDev.Categories[i].FriendlyName = 'DirectShow Filters' then
 begin
     G:=SysDev.Categories[i].CLSID;
 FilterEnum:=TSysDevEnum.Create(G);
     for j:= 0 to FilterEnum.CountFilters-1 do
   begin
     if FilterEnum.Filters[j].FriendlyName = 'LAV Splitter' then
     begin
       CLSID_LAV_SPLITTER:= FilterEnum.Filters[j].CLSID;
     //  CLSID_Component:= FilterEnum.Filters[j].CLSID;
     break;
     end;
   end;
 end;
end;
SysDev.Free;
FilterEnum.Free;

   hr := CoCreateInstance(CLSID_LAV_SPLITTER, nil, CLSCTX_INPROC_SERVER,
                       IID_IBaseFilter, LAVSplitter);
//hr := CoCreateInstance(CLSID_Component, nil, CLSCTX_INPROC_SERVER,
//                    IID_IBaseFilter, LAVSplitter);
(fgRender as IGraphBuilder).AddFilter(LAVSplitter,'LAV Splitter');
  }
//***************  type pin ******************
  ZeroMemory(@Mt, sizeof(AM_MEDIA_TYPE));
  Mt.MajorType := MEDIATYPE_Video;
  Mt.SubType := MEDIASUBTYPE_RGB32;
  Mt.FormatType := FORMAT_MPEG2_VIDEO;
  Mt.cbFormat := sizeof(MPEG2VIDEOINFO) + sizeof(seqHdr);
  mt.pbFormat := CoTaskMemAlloc(mt.cbFormat);

  //if (mt.pbFormat = NULL) then exit;   // ERROR

  ZeroMemory(mt.pbFormat, mt.cbFormat);

  RCSRC.Left := 0;
  RCSRC.Top:= 0;
  RCSRC.Right := 0;
  RCSRC.Bottom := 0;

  pWIH.hdr.rcSource.Left:=0;
  pWIH.hdr.rcSource.Top:=0;
  pWIH.hdr.rcSource.Right:=0;
  pWIH.hdr.rcSource.Bottom:=0;

  pWIH.hdr.rcSource := RCSRC;
//  pWIH.hdr.rcTarget := Rect(0,0,720,576);
  pWIH.hdr.rcTarget.Left:=0;
  pWIH.hdr.rcTarget.Top:=0;
  pWIH.hdr.rcTarget.Right:=576;
  pWIH.hdr.rcTarget.Bottom:=720;

  pWIH.hdr.AvgTimePerFrame := 278335;
  pWIH.hdr.dwPictAspectRatioX := 4;
  pWIH.hdr.dwPictAspectRatioY := 3;
  pWIH.hdr.bmiHeader.biSize := 40;
  pWIH.hdr.bmiHeader.biWidth := 720;
  pWIH.hdr.bmiHeader.biHeight := 576;
  pWIH.cbSequenceHeader := sizeof(seqHdr);
  CopyMemory(@pwih.dwSequenceHeader, @seqHdr, sizeof(seqhdr));
  // ********  connect pin *******************
  SourceFilter.FindPin('Output',PinOutSource);
 (VideoWindow1 as IBaseFilter).FindPin('Input',PIn_input);
 case PinOutSource.Connect(PIn_input,@mt) of
   S_OK                : showmessage('S_OK         ');
   E_POINTER           : showmessage('E_POINTER    ');
   VFW_E_NOT_CONNECTED : showmessage('VFW_E_NOT_CONNECTED ');
   VFW_E_CANNOT_CONNECT : showmessage('VFW_E_CANNOT_CONNECT');
   VFW_E_NOT_IN_GRAPH  : showmessage('VFW_E_NOT_IN_GRAPH ');
 end;

 //****************** GRAFICO ****************************
  //******************************************************
  hr := CoCreateInstance(CLSID_CaptureGraphBuilder2, nil, CLSCTX_INPROC_SERVER,
                        IID_ICaptureGraphBuilder2, ICapGraph);
 ICapGraph.SetFilterGraph(fgRender as IGraphBuilder);
 //*****************
 // ************   create InfinitePinFilterAudio *******
{ hr := CoCreateInstance(CLSID_InfTee, nil, CLSCTX_INPROC_SERVER,
                        IID_IBaseFilter, InfinitePinFilterAudio);
 (fgRender as IGraphBuilder).AddFilter(InfinitePinFilterAudio,'Infinite Pin Tee Audio');
 }
 //**************** Render Audio ************************************
 hr := ICapGraph.RenderStream(nil,nil, SourceFilter, nil, DefaultAudioFilter);
 // card decklink audio output
 //hr := ICapGraph.RenderStream(nil,nil, InfinitePinFilterAudio, nil, EstAudioInterFilter);



 //**************** create Infinite PIN Filter VIDEO *********
 {hr := CoCreateInstance(CLSID_InfTee, nil, CLSCTX_INPROC_SERVER,
                        IID_IBaseFilter, InfinitePinFilter);
 (fgRender as IGraphBuilder).AddFilter(InfinitePinFilter,'Infinite Pin Tee Video');
  }
 //******************** Render Video ************************
 hr := ICapGraph.RenderStream(nil, nil, SourceFilter, nil, VideoWindow1 as IBaseFilter);
   // card decklink   output   video
 //hr := ICapGraph.RenderStream(nil, nil, InfinitePinFilter, nil, IVideoRenderFilter);

 fgRender.Play;
 mc.Run;

end;

end.

